org.apache.lucene.search

## Interface Searchable

- All Known Subinterfaces:
    RMIRemoteSearchable
  All Known Implementing Classes:
    IndexSearcher, MultiSearcher, ParallelMultiSearcher, RemoteSearchable, Searcher

      public interface Searchable

  The interface for search implementations.

  Searchable is the abstract network protocol for searching. Implementations provide search over a single index, over multiple indices, and over indices on remote servers.

  Queries, filters and sort criteria are designed to be compact so that they may be efficiently passed to a remote index, with only the top-scoring hits being returned, rather than every matching hit. NOTE: this interface is kept public for convenience. Since it is not expected to be implemented directly, it may be changed unexpectedly between releases.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Frees resources associated with this Searcher.
    `Document` | `doc(int i)` Returns the stored fields of document `i`.
    `Document` | `doc(int n, FieldSelector fieldSelector)` Get the `Document` at the `n`th position.
    `int` | `docFreq(Term term)` Expert: Returns the number of documents containing `term`.
    `int[]` | `docFreqs(Term[] terms)` Expert: For each term in the terms array, calculates the number of documents containing `term`.
    `Explanation` | `explain(Weight weight, int doc)` Expert: low-level implementation method Returns an Explanation that describes how `doc` scored against `weight`.
    `int` | `maxDoc()` Expert: Returns one greater than the largest possible document number.
    `Query` | `rewrite(Query query)` Expert: called to re-write queries into primitive queries.
    `void` | `search(Weight weight, Filter filter, Collector collector)` Lower-level search API.
    `void` | `search(Weight weight, Filter filter, HitCollector results)` Deprecated. use `search(Weight, Filter, Collector)` instead.
    `TopDocs` | `search(Weight weight, Filter filter, int n)` Expert: Low-level search implementation.
    `TopFieldDocs` | `search(Weight weight, Filter filter, int n, Sort sort)` Expert: Low-level search implementation with arbitrary sorting.

- - ### Method Detail

    - #### search

          void search(Weight weight,
                      Filter filter,
                      HitCollector results)
               throws java.io.IOException

      Deprecated. use `search(Weight, Filter, Collector)` instead.
      Lower-level search API.

      `HitCollector.collect(int,float)` is called for every non-zero scoring document.
      HitCollector-based access to remote indexes is discouraged.

      Applications should only use this if they need all of the matching documents. The high-level search API (`Searcher.search(Query)`) is usually more efficient, as it skips non-high-scoring hits.

      Parameters:
        `weight` - to match documents
        `filter` - if non-null, used to permit documents to be collected.
        `results` - to receive hits
      Throws:
        `BooleanQuery.TooManyClauses`
        `java.io.IOException`

    - #### search

          void search(Weight weight,
                      Filter filter,
                      Collector collector)
               throws java.io.IOException

      Lower-level search API.

      `Collector.collect(int)` is called for every document.
      Collector-based access to remote indexes is discouraged.

      Applications should only use this if they need all of the matching documents. The high-level search API (`Searcher.search(Query)`) is usually more efficient, as it skips non-high-scoring hits.

      Parameters:
        `weight` - to match documents
        `filter` - if non-null, used to permit documents to be collected.
        `collector` - to receive hits
      Throws:
        `BooleanQuery.TooManyClauses`
        `java.io.IOException`

    - #### close

          void close()
              throws java.io.IOException

      Frees resources associated with this Searcher. Be careful not to call this method while you are still using objects like `Hits`.
      Throws:
        `java.io.IOException`

    - #### docFreq

          int docFreq(Term term)
               throws java.io.IOException

      Expert: Returns the number of documents containing `term`.
      Throws:
        `java.io.IOException`
      See Also:
        `IndexReader.docFreq(Term)`

    - #### docFreqs

          int[] docFreqs(Term[] terms)
                  throws java.io.IOException

      Expert: For each term in the terms array, calculates the number of documents containing `term`. Returns an array with these document frequencies. Used to minimize number of remote calls.
      Throws:
        `java.io.IOException`

    - #### maxDoc

          int maxDoc()
              throws java.io.IOException

      Expert: Returns one greater than the largest possible document number.
      Throws:
        `java.io.IOException`
      See Also:
        `IndexReader.maxDoc()`

    - #### search

          TopDocs search(Weight weight,
                         Filter filter,
                         int n)
                  throws java.io.IOException

      Expert: Low-level search implementation. Finds the top `n` hits for `query`, applying `filter` if non-null.

      Applications should usually call `Searcher.search(Query)` or `Searcher.search(Query,Filter)` instead.

      Throws:
        `BooleanQuery.TooManyClauses`
        `java.io.IOException`

    - #### doc

          Document doc(int i)
                throws CorruptIndexException,
                       java.io.IOException

      Returns the stored fields of document `i`.
      Throws:
        `CorruptIndexException` - if the index is corrupt
        `java.io.IOException` - if there is a low-level IO error
      See Also:
        `IndexReader.document(int)`

    - #### doc

          Document doc(int n,
                       FieldSelector fieldSelector)
                throws CorruptIndexException,
                       java.io.IOException

      Get the `Document` at the `n`th position. The `FieldSelector` may be used to determine what `Field`s to load and how they should be loaded. NOTE: If the underlying Reader (more specifically, the underlying `FieldsReader`) is closed before the lazy `Field` is loaded an exception may be thrown. If you want the value of a lazy `Field` to be available after closing you must explicitly load it or fetch the Document again with a new loader.
      Parameters:
        `n` - Get the document at the `n`th position
        `fieldSelector` - The `FieldSelector` to use to determine what Fields should be loaded on the Document. May be null, in which case all Fields will be loaded.
      Returns:
        The stored fields of the `Document` at the nth position
      Throws:
        `CorruptIndexException` - if the index is corrupt
        `java.io.IOException` - if there is a low-level IO error
      See Also:
        `IndexReader.document(int, FieldSelector)`, `Fieldable`, `FieldSelector`, `SetBasedFieldSelector`, `LoadFirstFieldSelector`

    - #### rewrite

          Query rewrite(Query query)
                 throws java.io.IOException

      Expert: called to re-write queries into primitive queries.
      Throws:
        `BooleanQuery.TooManyClauses`
        `java.io.IOException`

    - #### explain

          Explanation explain(Weight weight,
                              int doc)
                       throws java.io.IOException

      Expert: low-level implementation method Returns an Explanation that describes how `doc` scored against `weight`.

      This is intended to be used in developing Similarity implementations, and, for good performance, should not be displayed with every hit. Computing an explanation is as expensive as executing the query over the entire index.

      Applications should call `Searcher.explain(Query, int)`.

      Throws:
        `BooleanQuery.TooManyClauses`
        `java.io.IOException`

    - #### search

          TopFieldDocs search(Weight weight,
                              Filter filter,
                              int n,
                              Sort sort)
                       throws java.io.IOException

      Expert: Low-level search implementation with arbitrary sorting. Finds the top `n` hits for `query`, applying `filter` if non-null, and sorting the hits by the criteria in `sort`.

      Applications should usually call `Searcher.search(Query,Filter,int,Sort)` instead.

      Throws:
        `BooleanQuery.TooManyClauses`
        `java.io.IOException`

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.